=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2011-01-29 23:08:49 +0000
+++ drizzled/drizzled.cc	2011-02-02 12:51:57 +0000
@@ -357,6 +357,8 @@
 global_buffer_constraint<uint64_t> global_read_rnd_buffer(0);
 global_buffer_constraint<uint64_t> global_read_buffer(0);
 
+size_t transaction_message_threshold;
+
 /** 
   Refresh value. We use to test this to find out if a refresh even has happened recently.
 */
@@ -1032,13 +1034,13 @@
 
 static void check_limits_transaction_message_threshold(size_t in_transaction_message_threshold)
 {
-  global_system_variables.transaction_message_threshold= 1024*1024;
+  transaction_message_threshold= 1024*1024;
   if ((int64_t) in_transaction_message_threshold < 128*1024 || (int64_t)in_transaction_message_threshold > 1024*1024)
   {
     cout << _("Error: Invalid Value for transaction_message_threshold valid values are between 131072 - 1048576 bytes");
     exit(-1);
   }
-  global_system_variables.transaction_message_threshold= in_transaction_message_threshold;
+  transaction_message_threshold= in_transaction_message_threshold;
 }
 
 static void process_defaults_files()
@@ -1227,7 +1229,7 @@
   _("Path for temporary files."))
   ("transaction-isolation", po::value<string>(),
   _("Default transaction isolation level."))
-  ("transaction-message-threshold", po::value<size_t>(&global_system_variables.transaction_message_threshold)->default_value(1024*1024)->notifier(&check_limits_transaction_message_threshold),
+  ("transaction-message-threshold", po::value<size_t>(&transaction_message_threshold)->default_value(1024*1024)->notifier(&check_limits_transaction_message_threshold),
   _("Max message size written to transaction log, valid values 131072 - 1048576 bytes."))
   ("user,u", po::value<string>(),
   _("Run drizzled daemon as user."))  

=== modified file 'drizzled/drizzled.h'
--- drizzled/drizzled.h	2011-01-24 05:33:52 +0000
+++ drizzled/drizzled.h	2011-02-02 12:51:57 +0000
@@ -54,6 +54,8 @@
 extern global_buffer_constraint<uint64_t> global_read_rnd_buffer;
 extern global_buffer_constraint<uint64_t> global_read_buffer;
 
+extern size_t transaction_message_threshold;
+
 extern const char * const DRIZZLE_CONFIG_NAME;
 
 boost::program_options::variables_map &getVariablesMap();

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2011-01-28 21:08:33 +0000
+++ drizzled/session.h	2011-02-02 12:51:57 +0000
@@ -222,7 +222,6 @@
   size_t sortbuff_size;
   uint32_t thread_handling;
   uint32_t tx_isolation;
-  size_t transaction_message_threshold;
   uint32_t completion_type;
   /* Determines which non-standard SQL behaviour should be enabled */
   uint32_t sql_mode;

=== modified file 'drizzled/sys_var.cc'
--- drizzled/sys_var.cc	2011-01-26 19:15:55 +0000
+++ drizzled/sys_var.cc	2011-02-02 12:51:57 +0000
@@ -212,8 +212,8 @@
 static sys_var_session_size_t	sys_sort_buffer("sort_buffer_size",
                                                 &drizzle_system_variables::sortbuff_size);
 
-static sys_var_session_size_t sys_transaction_message_threshold("transaction_message_threshold",
-                                                                &drizzle_system_variables::transaction_message_threshold);
+static sys_var_size_t_ptr_readonly sys_transaction_message_threshold("transaction_message_threshold",
+                                                                &transaction_message_threshold);
 
 static sys_var_session_storage_engine sys_storage_engine("storage_engine",
 				       &drizzle_system_variables::storage_engine);

=== modified file 'drizzled/sys_var.h'
--- drizzled/sys_var.h	2011-01-26 19:15:55 +0000
+++ drizzled/sys_var.h	2011-02-02 12:51:57 +0000
@@ -75,6 +75,7 @@
 extern bool opt_readonly;
 extern char *default_tz_name;
 extern const char *opt_scheduler;
+extern size_t transaction_message_threshold;
 
 uint64_t fix_unsigned(Session *, uint64_t, const struct option *);
 
@@ -316,6 +317,16 @@
   { return (unsigned char*) value; }
 };
 
+class DRIZZLED_API sys_var_size_t_ptr_readonly :public sys_var_size_t_ptr
+{
+public:
+  sys_var_size_t_ptr_readonly(const char *name_arg,
+                            size_t *value_arg)
+    :sys_var_size_t_ptr(name_arg, value_arg)
+  {}
+  bool is_readonly() const { return 1; }
+};
+
 class DRIZZLED_API sys_var_bool_ptr :public sys_var
 {
   bool default_value;

=== modified file 'drizzled/transaction_services.cc'
--- drizzled/transaction_services.cc	2011-01-24 21:05:10 +0000
+++ drizzled/transaction_services.cc	2011-02-02 12:51:57 +0000
@@ -1264,7 +1264,7 @@
     transaction= getActiveTransactionMessage(session);
 
     if (static_cast<size_t>(transaction->ByteSize()) >= 
-        session.variables.transaction_message_threshold)
+        transaction_message_threshold)
     {
       transaction= segmentTransactionMessage(session, transaction);
     }
@@ -1283,7 +1283,7 @@
      * the Transaction will keep it from getting huge).
      */
     if (static_cast<size_t>(transaction->ByteSize()) >= 
-        session.variables.transaction_message_threshold)
+        transaction_message_threshold)
     {
       /* Remember the transaction ID so we can re-use it */
       uint64_t trx_id= transaction->transaction_context().transaction_id();
@@ -1450,7 +1450,7 @@
     transaction= getActiveTransactionMessage(session);
     
     if (static_cast<size_t>(transaction->ByteSize()) >= 
-        session.variables.transaction_message_threshold)
+        transaction_message_threshold)
     {
       transaction= segmentTransactionMessage(session, transaction);
     }
@@ -1469,7 +1469,7 @@
      * the Transaction will keep it from getting huge).
      */
     if (static_cast<size_t>(transaction->ByteSize()) >= 
-        session.variables.transaction_message_threshold)
+        transaction_message_threshold)
     {
       /* Remember the transaction ID so we can re-use it */
       uint64_t trx_id= transaction->transaction_context().transaction_id();
@@ -1722,7 +1722,7 @@
     transaction= getActiveTransactionMessage(session);
     
     if (static_cast<size_t>(transaction->ByteSize()) >= 
-        session.variables.transaction_message_threshold)
+        transaction_message_threshold)
     {
       transaction= segmentTransactionMessage(session, transaction);
     }
@@ -1741,7 +1741,7 @@
      * the Transaction will keep it from getting huge).
      */
     if (static_cast<size_t>(transaction->ByteSize()) >= 
-        session.variables.transaction_message_threshold)
+        transaction_message_threshold)
     {
       /* Remember the transaction ID so we can re-use it */
       uint64_t trx_id= transaction->transaction_context().transaction_id();

=== modified file 'plugin/innobase/handler/replication_dictionary.cc'
--- plugin/innobase/handler/replication_dictionary.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/handler/replication_dictionary.cc	2011-02-02 12:51:57 +0000
@@ -57,6 +57,8 @@
 #include "read_replication.h"
 #include "handler0vars.h"
 
+#include "drizzled/drizzled.h"
+
 #include "drizzled/replication_services.h"
 
 #include <google/protobuf/io/zero_copy_stream.h>
@@ -75,8 +77,8 @@
   plugin::TableFunction("DATA_DICTIONARY", "INNODB_REPLICATION_LOG")
 {
   add_field("TRANSACTION_ID", plugin::TableFunction::NUMBER, 0, false);
-  add_field("TRANSACTION_MESSAGE_STRING", plugin::TableFunction::STRING, 2048, false);
-  add_field("TRANSACTION_MESSAGE_BINARY", plugin::TableFunction::VARBINARY, 2048, false);
+  add_field("TRANSACTION_MESSAGE_STRING", plugin::TableFunction::STRING, transaction_message_threshold, false);
+  add_field("TRANSACTION_MESSAGE_BINARY", plugin::TableFunction::VARBINARY, transaction_message_threshold, false);
   add_field("TRANSACTION_LENGTH", plugin::TableFunction::NUMBER, 0, false);
 }
 

